/* Maximum flow - highest lavel push-relabel algorithm */
/* COPYRIGHT C 1995, 2000 by IG Systems, Inc., igsys@eclipse.net */

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "timer.c"                     /* timing routine */
#include <map>
#include <algorithm>
#include <fstream>

#include "hi_pr.hpp"
// #include "task.hpp"
#include "tree.hpp"

using namespace std;

static void print_node_map(int *part, int n);


int main (int argc, char *argv[])
{
  if (argc != 2)
    {
      cout << argv[0] << " graph.dimacs" << endl;
      exit(1);
    }
   ifstream graph_file(argv[1]);
   
   // common variables
   Edgelist G;   // input graph
   G.read_dimacs(graph_file); // read the input graph
   int N = G.num_nodes();
   
   // cout << G;

   // -------------- era o slave
   hi_pr_init(G.num_nodes(), G.num_edges());
    
   vector<bool> cut(N);
   
   // CALL HI_PR
   double time;
   int num_of_cuts;

   double flow = hi_pr(G, cut, true, time, num_of_cuts); 
   
   return 0;  

}
