/* defs.h */

#ifdef EXCESS_TYPE_LONG
typedef unsigned long excessType;
#else
typedef unsigned long long int excessType; /* change to double if not supported */
#endif

/* was unsigned long */
typedef long cType;

typedef  /* arc */
   struct arcSt
{
   cType           resCap;          /* residual capasity */
   struct nodeSt   *head;           /* arc head */
   struct arcSt    *rev;            /* reverse arc */
}
  arc;

typedef  /* node */
   struct nodeSt
{
   arc             *first;           /* first outgoing arc */
   arc             *current;         /* current outgoing arc */
   excessType      excess;           /* excess at the node 
				        change to double if needed */
   long            d;                /* distance label */
   struct nodeSt   *bNext;           /* next node in bucket */
   struct nodeSt   *bPrev;           /* previous node in bucket */
} node;


typedef /* bucket */
   struct bucketSt
{
  node             *firstActive;      /* first node with positive excess */
  node             *firstInactive;    /* first node with zero excess */
} bucket;

typedef  /* arc */
   struct scc_arcSt
{
  //  cType           resCap;          /* residual capasity */
  struct scc_nodeSt   *head;           /* arc head */
  // struct scc_arcSt    *rev;            /* reverse arc */
  struct scc_arcSt    *next;           /* next edge on the adjacency list */ 
} scc_arc;

typedef  /* node */
   struct scc_nodeSt
{
  scc_arc*            first_edge;      // first outgoing arc
  scc_arc*            current;         // current outgoing arc 
  scc_arc*            first_rev_edge;  // first outgoing arc in the reverse graph
  scc_arc*            rev_current;     // current outgoing reverse edge
  node*               first_vertex;    // first vertex in the scc represented by this node
  scc_nodeSt*         pred;            // parent in the dfs tree
  bool                in_S;             // used by the cut enumeration algorithm 
  bool                in_T;             // used by the cut enumeration algorithm 
  int                 outdegree;       // outdegree in \overline{S} 
  int                 size;            // number of vertices in this condensed node
} scc_node;

